<?php
// main post parser
function main_post_parser()
{
	global $site_config;
	
	$_POST['body1'] = htmlspecialchars($_POST['body1']);
	
	// Smilies
	$grab_smilies = mysql_query("SELECT * FROM `smilies` ORDER BY `id`");
	while ($echo_smilies = mysql_fetch_array($grab_smilies))
	{
		$echo_smilies['code'] = htmlspecialchars($echo_smilies['code']);
		$_POST['body1'] = str_replace($echo_smilies['code'],"<img src=\"{$site_config['site_url']}{$echo_smilies['image']}\" />",$_POST['body1']);
	}
	
	// Bold code
	$_POST['body1'] = str_replace("[b]","<strong>",$_POST['body1']);
	$_POST['body1'] = str_replace("[/b]","</strong>",$_POST['body1']);
		
	// Underline code
	$_POST['body1'] = str_replace("[u]","<u>",$_POST['body1']);
	$_POST['body1'] = str_replace("[/u]","</u>",$_POST['body1']);
		
	// Italic code
	$_POST['body1'] = str_replace("[i]","<em>",$_POST['body1']);
	$_POST['body1'] = str_replace("[/i]","</em>",$_POST['body1']);
		
	// New line code
	$_POST['body1'] = str_replace("\n","<br />",$_POST['body1']);
	
	// images
	$_POST['body1'] = str_replace('[img]', '<img border="0" src="', $_POST['body1']);
	$_POST['body1'] = str_replace('[/img]', '" alt="user posted image">', $_POST['body1']);
	
	// quote
	$_POST['body1'] = str_replace('[quote]', '<div class="quote">', $_POST['body1']);
	$_POST['body1'] = str_replace('[/quote]', '</div>', $_POST['body1']);
	
	// code
	$_POST['body1'] = str_replace('[code]', '<span class="code">', $_POST['body1']);
	$_POST['body1'] = str_replace('[/code]', '</span>', $_POST['body1']);
	
	// Urls
	$_POST['body1'] = preg_replace("`(?<=^|[\n ]|\.)http://([\w]*[\w\.\?\/&=\;-]+)`","[url=http://\\1]http://\\1[/url]",$_POST['body1']);
	$_POST['body1'] = preg_replace("`(?<=^|[\n ]|\.)www\.([\w\.\?\/&=\;-]+)`","[url=http://www.\\1]www.\\1[/url]",$_POST['body1']);
	
	$_POST['body1'] = preg_replace("`\[url\]([\w]*[:\/\/]*[\w\.\?\/&=\;, -@]+)\[/url\]`sUi","<a href=\'\\1\' rel=\'nofollow\'>\\1</a>",$_POST['body1']);
	$_POST['body1'] = preg_replace("`\[url\=([\w]*[:\/\/]*[\w\.\?\/&=\;, -@]+)\](.*)\[/url\]`sUi","<a href=\'\\1\' rel=\'nofollow\'>\\2</a>",$_POST['body1']);
	
	// try to remove XSS Cross-site scripting issues.
	$_POST['body1'] = preg_replace("#javascript:#i", "java script:", $_POST['body1']);
	$_POST['body1'] = preg_replace("#alert#i", "&#097;lert", $_POST['body1']);
	$_POST['body1'] = preg_replace("#onmouseover#i", "&#111;nmouseover", $_POST['body1']);
	$_POST['body1'] = preg_replace("#onclick#i", "&#111;nclick", $_POST['body1']);
	$_POST['body1'] = preg_replace("#onload#i", "&#111;nload", $_POST['body1']);
	$_POST['body1'] = eregi_replace("#onsubmit#i", "&#111;nsubmit", $_POST['body1']);
	
	if(!get_magic_quotes_gpc()) 
	{
		$_POST['body1'] = addslashes($_POST['body1']);
	}
}

// edit post parser
function edit_post_parser($edit)
{	
	global $site_config;
	
	/// To display correctly for editing!	
	// Replace new lines
	$edit = str_replace("<br />","\n",$edit);
	
	// Bold code
	$edit = str_replace("<strong>","[b]",$edit);
	$edit = str_replace("</strong>","[/b]",$edit);
		
	// Underline code
	$edit = str_replace("<u>","[u]",$edit);
	$edit = str_replace("</u>","[/u]",$edit);
		
	// Italic code
	$edit = str_replace("<em>","[i]",$edit);
	$edit = str_replace("</em>","[/i]",$edit);
	
	// Images
	$edit = str_replace('<img border="0" src="', '[img]', $edit);
	$edit = str_replace('" alt="user posted image">', '[/img]', $edit);
	
	// Quote
	$edit = str_replace('<div class="quote">', '[quote]', $edit);
	$edit = str_replace('</div>', '[/quote]', $edit);
	
	// Code
	$edit = str_replace('<span class="code">', '[code]', $edit);
	$edit = str_replace('</span>', '[/code]', $edit);
			
	// Gimme smilies!
	$grab_smilies = mysql_query("SELECT * FROM `smilies` ORDER BY `id`");
	while ($echo_smilies = mysql_fetch_array($grab_smilies))
	{
		$edit = str_replace("<img src=\"{$site_config['site_url']}{$echo_smilies['image']}\" />",$echo_smilies['code'],$edit);
	}
		
	// Strip the slashes
	$edit = stripslashes($edit);
	
	return $edit;
}
?>